/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getIntArrayOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getIntArrayOperationDispatcher. It contains of all the generic methods
    for getIntArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getIntArrayOperationDispatcher_HXX
#define getIntArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getIntArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getIntArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getIntArrayOperationDispatcher();
        virtual ~getIntArrayOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getIntArrayPreConditions( const Teamcenter::BusinessObject* obj, std::vector<int>& intValues, std::vector<int>& isNullValues ) const;
        void getIntArrayPreActions( const Teamcenter::BusinessObject* obj, std::vector<int>& intValues, std::vector<int>& isNullValues ) const;
        void getIntArrayBaseAction( const Teamcenter::BusinessObject* obj, std::vector<int>& intValues, std::vector<int>& isNullValues ) const;
        void getIntArrayPostActions( const Teamcenter::BusinessObject* obj, std::vector<int>& intValues, std::vector<int>& isNullValues ) const;

        // Project 011450 changes
        void getIntArrayPreConditions( METHOD_message_t*  msgData, int* num, int** value, logical** isNull ) const;
        void getIntArrayPreActions( METHOD_message_t*  msgData, int* num, int** value, logical** isNull ) const;
        void getIntArrayBaseAction( METHOD_message_t*  msgData, int* num, int** value, logical** isNull ) const;
        void getIntArrayPostActions( METHOD_message_t*  msgData, int* num, int** value, logical** isNull ) const;

        void getIntArray( const Teamcenter::BusinessObject* obj, std::vector<int>& intValues, std::vector<int>& isNullValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getIntArrayOperationDispatcher_HXX
